SystemOrganization addCategory: #ConfigurationOfObjectUsageTracer!

Object subclass: #ConfigurationOfObjectUsageTracer
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfObjectUsageTracer'!

!ConfigurationOfObjectUsageTracer class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
project

	^self new project! !

!ConfigurationOfObjectUsageTracer class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfObjectUsageTracer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 18:44'!
baseline10: spec 
        <version: '1.0-baseline'>
        
	spec for: #pharo do: [
		
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/ObjectUsageTracer'.
	
		spec package: 'ObjectUsageTracerCogVMMaker'
			with: [ spec requires: #('ExperimentalBitVM') ].
					
		spec
			project: 'ExperimentalBit' with: [
			spec
				className: 'ConfigurationOfExperimentalBit';
				loads: #('default' );
				file: 'ConfigurationOfExperimentalBit';
				"Don't use #bleedingEdge because we need to be in zinc with platform code"
				repository: 'http://ss3.gemstone.com/ss/ExperimentalBit' ].
	
		spec
			project: 'ExperimentalBitVM' with: [
			spec
				className: 'ConfigurationOfExperimentalBit';
				loads: #('VMMakerGroup' );
				file: 'ConfigurationOfExperimentalBit';
				"Don't use #bleedingEdge because we need to be in zinc with platform code"
				repository: 'http://ss3.gemstone.com/ss/ExperimentalBit';
				postLoadDoIt: #prepareVMForObjectUsageTracer ].
		
	
		spec
 		"	group: 'default' with: #('ExperimentalBit' );"
			group: 'VMMakerGroup' with: #( 'ObjectUsageTracerCogVMMaker' 'ExperimentalBitVM' ).

	
	]! !

!ConfigurationOfObjectUsageTracer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 18:43'!
prepareVMForObjectUsageTracer
	(Smalltalk at: #StackInterpreter) addInstVarNamed: 'hasToTrace'.! !

!ConfigurationOfObjectUsageTracer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 18:30'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfObjectUsageTracer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 18:44'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
        
	spec for: #pharo do: [
		
		spec blessing: #development.
		spec author: 'Mariano Martinez Peck'.
		spec description: '  Needed GIT  blessed repository, version: commit 4a65655f0e419248d09a2502ea13b6e787992691
 		'.
		
		spec project: 'ExperimentalBitVM' with: '1.0'.
	
	]! !
